/**************************************************************************
                 fmwav.h  -  writing and reading .wav-files
                            -------------------
    begin                : June 20th 2002
    copyright            : (C) 2002 by Daniel Gruen
    email                : daniel_gruen@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FMWAV_
#define _FMWAV_

#include "vtl.h"

struct wavFile{
	int length;
	float * data;
};

bool writeWavHeader(char * filename, int datalength, int rate, int chan, int bytes);
bool writeWavByte  (char * byte, int bytes);
void cleanup_wav();
wavFile readWav(char * filename);
wavFile truncWav(wavFile w, float l=100.0);
FAP* fouAnalyse(wavFile t, int N2=20, bool usephase=0, float ll=0.00005);
int findHigh(wavFile w, float highl, int offset=0);
int findLow (wavFile w, float  lowl, int offset=0);
void charToFloat(int byterate, int n, char *c, float *f);

#endif
